## unity 4.30.0

=== CMakeLists.txt ===
project (unity)
cmake_minimum_required(VERSION 2.8)


include (cmake/Documentation.cmake)

subdirs (doc services tests tools UnityCore guides)

#
# Base bits
#
set (PROJECT_NAME "unity")
set (UNITY_MAJOR 4)
set (UNITY_MINOR 30)
set (UNITY_MICRO 0)
set (UNITY_VERSION "${UNITY_MAJOR}.${UNITY_MINOR}.${UNITY_MICRO}")
set (UNITY_API_VERSION "4.0")

set (CMAKE_CXX_FLAGS "-DGNOME_DESKTOP_USE_UNSTABLE_API -std=c++0x -fno-permissive")
set (CMAKE_CXX_FLAGS_DEBUG "-g3")
set (CMAKE_CXX_FLAGS_RELEASE "")

#
# Niceties
#
set (ARCHIVE_NAME unity-${UNITY_VERSION})

add_custom_target (pre-distcheck
  COMMAND echo ""
       && echo "• Releasing Unity ${UNITY_VERSION}"
       && cd ${CMAKE_SOURCE_DIR}
       && echo "• Generating ChangeLog"
       && bzr log --gnu-changelog > ChangeLog
       && echo "• Generating AUTHORS"
       && bzr log --long --levels=0 | grep -e "^\\s*author:" -e "^\\s*committer:" | cut -d ":" -f 2 | sed -r -f AUTHOR-glue | sort -u > AUTHORS
       && echo "• Committing Release"
       && bzr commit -m"Release ${UNITY_VERSION}" --unchanged
       && echo "• Tagging Release"
       && bzr tag ${UNITY_VERSION}
       && echo "• Running Distcheck"
  )
  
add_custom_target (dist
  COMMAND bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
add_dependencies(dist pre-distcheck)

add_custom_target (distcheck
  COMMAND cd ${CMAKE_BINARY_DIR}
       && rm -rf ${ARCHIVE_NAME}
       && tar xf ${ARCHIVE_NAME}.tar.bz2
       && mkdir ${ARCHIVE_NAME}/build
       && cd ${ARCHIVE_NAME}/build
       && cmake -DCMAKE_INSTALL_PREFIX=../install -DGSETTINGS_LOCALINSTALL=ON .. -DCMAKE_MODULE_PATH=/usr/share/cmake
       && make -j4
       && make -j4 install
       && make check
  )
add_dependencies(distcheck dist)

add_custom_target (post-distcheck
  COMMAND echo "• Signing Tarball"
       && gpg --armor --sign --detach-sig ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
       && echo "• Pushing Branch"
       && bzr push
       && echo "• Publishing Tarball"
       && lp-project-upload unity ${UNITY_VERSION} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
       && echo ""
       && echo "• Unity ${UNITY_VERSION} Released."
  )
add_dependencies(post-distcheck distcheck)

add_custom_target (release)
add_dependencies (release post-distcheck)

#
# config.h
#
set (PREFIXDIR "${CMAKE_INSTALL_PREFIX}")
set (DATADIR "${CMAKE_INSTALL_PREFIX}/share")
set (PKGDATADIR "${DATADIR}/unity/${UNITY_MAJOR}")
set (GETTEXT_PACKAGE "unity")
set (LOCALE_DIR "${DATADIR}/locale")
set (VERSION "${UNITY_VERSION}")
set (BUILDDIR "${CMAKE_BINARY_DIR}")

configure_file (${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_BINARY_DIR}/config.h)

#
# i18n
#
find_package (Gettext REQUIRED)

add_custom_command (OUTPUT ${CMAKE_SOURCE_DIR}/po/unity.pot
		COMMAND xgettext -c --files-from ${CMAKE_SOURCE_DIR}/po/POTFILES.in --keyword=_ -o ${CMAKE_SOURCE_DIR}/po/unity.pot --copyright-holder="Canonical Ltd" --msgid-bugs-address="ayatana-dev@lists.launchpad.net" --no-wrap --no-location
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		)

if (${GETTEXT_FOUND} STREQUAL "TRUE")
        set (HAVE_GETTEXT true)
        file (GLOB _translations ${CMAKE_SOURCE_DIR}/po/*.po)
        GETTEXT_CREATE_TRANSLATIONS (${CMAKE_SOURCE_DIR}/po/${PROJECT_NAME}.pot
                ALL ${_translations})
endif (${GETTEXT_FOUND} STREQUAL "TRUE")

#
# Enable or disable boot logging
# 
option (BOOT_LOGGER "Enable startup performance logging" OFF)
if (BOOT_LOGGER)
    SET (BOOT_LOGGER_FLAG "-DENABLE_LOGGER")
endif (BOOT_LOGGER)

SET (MAINTAINER_CFLAGS "-Werror -Wall -Wcast-align -Wno-uninitialized -Wempty-body -Wformat-security -Winit-self -Warray-bounds")
option (DISABLE_MAINTAINER_CFLAGS "Disable maintainer CFlags" OFF)
if (DISABLE_MAINTAINER_CFLAGS)
  SET (MAINTAINER_CFLAGS "")
endif (DISABLE_MAINTAINER_CFLAGS)

#
# Compiz Plugins
#
set (UNITY_PLUGIN_DEPS "compiz;nux-1.0 >= 1.2.2;libbamf3;dee-1.0;gio-2.0;gio-unix-2.0;dbusmenu-glib-0.4;x11;libstartup-notification-1.0;gthread-2.0;indicator3-0.4;atk;unity-misc >= 0.4.0;gconf-2.0;libgeis;gtk+-3.0 >= 3.1;sigc++-2.0;json-glib-1.0;libnotify;gnome-desktop-3.0")


find_package (Compiz REQUIRED)
include (CompizPlugin)

compiz_add_plugins_in_folder ("${CMAKE_SOURCE_DIR}/plugins/")

#
# GSettings Schema
#
SET (UNITY_SCHEMAS "com.canonical.Unity.gschema.xml")

# Have an option to not install the schema into where GLib is
option (GSETTINGS_LOCALINSTALL "Install GSettings Schemas locally instead of to the GLib prefix" OFF)
if (GSETTINGS_LOCALINSTALL)
    SET (GSETTINGS_DIR "${CMAKE_INSTALL_PREFIX}/share/glib-2.0/schemas/")
else (GSETTINGS_LOCALINSTALL)
    execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} glib-2.0 --variable prefix  OUTPUT_VARIABLE _glib_prefix OUTPUT_STRIP_TRAILING_WHITESPACE)
    SET (GSETTINGS_DIR "${_glib_prefix}/share/glib-2.0/schemas/")
endif (GSETTINGS_LOCALINSTALL)

# Run the validator and error if it fails
execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} gio-2.0 --variable glib_compile_schemas  OUTPUT_VARIABLE _glib_comple_schemas OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process (COMMAND ${_glib_comple_schemas} --dry-run --schema-file=${CMAKE_CURRENT_SOURCE_DIR}/${UNITY_SCHEMAS} ERROR_VARIABLE _schemas_invalid OUTPUT_STRIP_TRAILING_WHITESPACE)

if (_schemas_invalid)
  message (SEND_ERROR "Schema validation error: ${_schemas_invalid}")
endif (_schemas_invalid)

# Actually install and recomple schemas
message (STATUS "GSettings schemas will be installed into ${GSETTINGS_DIR}")
install (FILES ${UNITY_SCHEMAS} DESTINATION ${GSETTINGS_DIR} OPTIONAL)
install (CODE "message (STATUS \"Compiling GSettings schemas\")")
install (CODE "execute_process (COMMAND ${_glib_comple_schemas} ${GSETTINGS_DIR})")

# For testing
configure_file (${CMAKE_SOURCE_DIR}/${UNITY_SCHEMAS} ${CMAKE_BINARY_DIR}/settings/${UNITY_SCHEMAS})
execute_process (COMMAND ${_glib_comple_schemas} ${CMAKE_BINARY_DIR}/settings)

#
# docs
#

# check if doxygen is even installed
find_package(Doxygen)
if (DOXYGEN_FOUND STREQUAL "NO")
  message("Doxygen not found. Documentation will not be built")
endif (DOXYGEN_FOUND STREQUAL "NO")

if (DOXYGEN_FOUND STREQUAL "YES")
  set(TOP_SRCDIR ${CMAKE_CURRENT_SOURCE_DIR})

  # prepare doxygen configuration file
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

  # add doxygen as target
  add_custom_target(doxygen ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

  # cleanup $build/api-doc on "make clean"
  set_property(DIRECTORY APPEND PROPERTY
         ADDITIONAL_MAKE_CLEAN_FILES api-doc)

endif (DOXYGEN_FOUND STREQUAL "YES")

=== UnityCore/CMakeLists.txt ===
find_package (PkgConfig)
pkg_check_modules (CORE_DEPS REQUIRED glib-2.0 gio-2.0 dee-1.0 sigc++-2.0 nux-core-1.0 gdk-pixbuf-2.0 unity)

execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} unity --variable lensesdir OUTPUT_VARIABLE _lensesdir OUTPUT_STRIP_TRAILING_WHITESPACE)

#
# Headers & Sources
#
set (CORE_HEADERS
     ApplicationPreview.h
     Categories.h
     Category.h
     CheckOptionFilter.h
     DBusIndicators.h
     FilesystemLenses.h
     Filter.h
     Filters.h
     GenericPreview.h
     GLibDBusProxy.h
     GLibSignal.h
     GLibSignal-inl.h
     GLibWrapper.h
     GLibWrapper-inl.h
     IndicatorEntry.h
     Indicator.h
     Indicators.h
     Lens.h
     Lenses.h
     MultiRangeFilter.h
     MusicPreviews.h
     Model.h
     Model-inl.h
     ModelRowAdaptor.h
     ModelRowAdaptor-inl.h
     Preview.h
     Utils.h
     RadioOptionFilter.h
     RatingsFilter.h
     Result.h
     Results.h
     Variant.h
    )

set (CORE_SOURCES
     ApplicationPreview.cpp
     Categories.cpp
     Category.cpp
     CheckOptionFilter.cpp
     DBusIndicators.cpp
     FilesystemLenses.cpp
     Filter.cpp
     Filters.cpp
     GenericPreview.cpp
     GLibDBusProxy.cpp
     GLibSignal.cpp
     GLibWrapper.cpp
     Indicator.cpp
     IndicatorEntry.cpp
     Indicators.cpp
     Lens.cpp
     MultiRangeFilter.cpp
     MusicPreviews.cpp
     ModelRowAdaptor.cpp
     Preview.cpp
     RatingsFilter.cpp
     RadioOptionFilter.cpp
     Result.cpp
     Results.cpp
     Variant.cpp
    )

#
# CFLAGS and LIBS
#
set (CFLAGS
     ${CORE_DEPS_CFLAGS}
     ${CORE_DEPS_CFLAGS_OTHER}
     ${MAINTAINER_CFLAGS}
     "-I${CMAKE_BINARY_DIR}"
     "-DGETTEXT_PACKAGE=\"unity\""
     "-DLENSES_DIR=\"${_lensesdir}\""
     )
add_definitions (${CFLAGS})

set (LIBS ${CORE_DEPS_LIBRARIES})
link_libraries (${LIBS})

set (LIB_PATHS ${CORE_DEPS_LIBRARY_DIRS})
link_directories(${LIB_PATHS})

#
# Library
#
# Before making a release, the version string should be updated.
# The string is of the form C:R:A.
# - If interfaces have been changed or added, but binary compatibility has
#   been preserved, change to C+1:0:A+1
# - If binary compatibility has been broken (eg removed or changed interfaces)
#   change to C+1:0:0
# - If the interface is the same as the previous version, change to C:R+1:A
set (CORE_LIB_LT_CURRENT 4)
set (CORE_LIB_LT_REV 0)
set (CORE_LIB_LT_AGE 0)
set (CORE_LIB_LT_VERSION "${CORE_LIB_LT_CURRENT}:${CORE_LIB_LT_REV}:${CORE_LIB_LT_AGE}")

set (CORE_LIB_NAME "unity-core-${UNITY_API_VERSION}")
add_library (${CORE_LIB_NAME} SHARED ${CORE_SOURCES})
set_target_properties(${CORE_LIB_NAME} PROPERTIES
                      VERSION ${CORE_LIB_LT_CURRENT}.${CORE_LIB_LT_REV}.${CORE_LIB_LT_AGE}
                      SOVERSION ${CORE_LIB_LT_CURRENT})

install (TARGETS ${CORE_LIB_NAME}
         RUNTIME DESTINATION bin
         ARCHIVE DESTINATION lib
         LIBRARY DESTINATION lib
        )

#
# Headers
#
install (FILES ${CORE_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/include/Unity-${UNITY_API_VERSION}/UnityCore)

#
# PkgConfig file
#
set (EXEC_PREFIX "${CMAKE_INSTALL_PREFIX}")
set (LIBDIR "${CMAKE_INSTALL_PREFIX}/lib")
set (INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")

configure_file (unity-core.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/${CORE_LIB_NAME}.pc)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${CORE_LIB_NAME}.pc DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig)

=== tests/CMakeLists.txt ===
set(UNITY_SRC ../plugins/unityshell/src)

#
# Data
#
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/data/update-manager.desktop
                ${CMAKE_BINARY_DIR}/tests/data/update-manager.desktop)
#
# Unit tests
#
find_package (PkgConfig)
set (TEST_DEPS "${UNITY_PLUGIN_DEPS};unity>=4.0.0")
pkg_check_modules (TEST_UNIT_DEPS REQUIRED ${TEST_DEPS})

set (TESTDATADIR "${CMAKE_CURRENT_SOURCE_DIR}/data")

set (CFLAGS
     ${TEST_UNIT_DEPS_CFLAGS}
     ${TEST_UNIT_DEPS_CFLAGS_OTHER}
     ${MAINTAINER_CFLAGS}
     "-g"
     "-DTESTDATADIR=\"${TESTDATADIR}\""
     "-DGETTEXT_PACKAGE=\"unity\""
     "-DINDICATORDIR=\"${CMAKE_BINARY_DIR}/tests\""
     "-DINDICATORICONDIR=\"${CMAKE_BINARY_DIR}/tests\""
     "-I${CMAKE_CURRENT_BINARY_DIR}"
     )
add_definitions (${CFLAGS})

set (LIBS ${TEST_UNIT_DEPS_LIBRARIES} "-lunity-core-${UNITY_API_VERSION} -lm")
link_libraries (${LIBS})

set (LIB_PATHS ${TEST_UNIT_DEPS_LIBRARY_DIRS})
link_directories (${CMAKE_BINARY_DIR}/UnityCore ${LIB_PATHS})

include_directories (. .. ../services ../UnityCore ${UNITY_SRC} ${CMAKE_BINARY_DIR})

# We can't have convenience libs so we need to rebuild with what we need
# Please keep actual test files alphabetically at top and then files
# from ../${UNITY_SRC} or ../../services in alphabetically after that
add_executable (test-unit
                unit/TestQuicklistMenuitems.cpp
                unit/TestMain.cpp
                unit/TestUBus.cpp
                ${UNITY_SRC}/ubus-server.cpp
                ${UNITY_SRC}/ubus-server.h
                ${UNITY_SRC}/Introspectable.cpp
                ${UNITY_SRC}/QuicklistMenuItem.cpp
                ${UNITY_SRC}/QuicklistMenuItem.h
                ${UNITY_SRC}/QuicklistMenuItemCheckmark.cpp
                ${UNITY_SRC}/QuicklistMenuItemCheckmark.h
                ${UNITY_SRC}/QuicklistMenuItemLabel.cpp
                ${UNITY_SRC}/QuicklistMenuItemLabel.h
                ${UNITY_SRC}/QuicklistMenuItemRadio.cpp
                ${UNITY_SRC}/QuicklistMenuItemRadio.h
                ${UNITY_SRC}/QuicklistMenuItemSeparator.cpp
                ${UNITY_SRC}/QuicklistMenuItemSeparator.h
                ${UNITY_SRC}/QuicklistView.cpp
                ${UNITY_SRC}/QuicklistView.h
                ${UNITY_SRC}/
                )
add_dependencies (test-unit unity-core-${UNITY_API_VERSION})

#
# Standalone tests
#
add_executable (standalone-dash
                standalone_dash.cpp
                ${UNITY_SRC}/BackgroundEffectHelper.cpp
                ${UNITY_SRC}/BackgroundEffectHelper.h
                ${UNITY_SRC}/BGHash.cpp
                ${UNITY_SRC}/BGHash.h
                ${UNITY_SRC}/DashSearchBar.cpp
                ${UNITY_SRC}/DashSearchBar.h
                ${UNITY_SRC}/DashSearchBarSpinner.cpp
                ${UNITY_SRC}/DashSearchBarSpinner.h
                ${UNITY_SRC}/FilterExpanderLabel.cpp
                ${UNITY_SRC}/FilterFactory.cpp
                ${UNITY_SRC}/FilterBasicButton.cpp
                ${UNITY_SRC}/FilterRatingsButton.cpp
                ${UNITY_SRC}/FilterRatingsWidget.cpp
                ${UNITY_SRC}/FilterMultiRangeWidget.cpp
                ${UNITY_SRC}/FilterMultiRangeButton.cpp
                ${UNITY_SRC}/FilterGenreButton.cpp
                ${UNITY_SRC}/FilterGenreWidget.cpp
                ${UNITY_SRC}/FilterBar.cpp
                ${UNITY_SRC}/FontSettings.cpp
                ${UNITY_SRC}/FontSettings.h
                ${UNITY_SRC}/IMTextEntry.cpp
                ${UNITY_SRC}/IMTextEntry.h
                ${UNITY_SRC}/PlacesHomeView.cpp
                ${UNITY_SRC}/PlacesHomeView.h
                ${UNITY_SRC}/PlacesGroup.cpp
                ${UNITY_SRC}/PlacesGroup.h
                ${UNITY_SRC}/DashSettings.cpp
                ${UNITY_SRC}/DashSettings.h
                ${UNITY_SRC}/PlacesStyle.cpp
                ${UNITY_SRC}/PlacesStyle.h
                ${UNITY_SRC}/PlacesTile.cpp
                ${UNITY_SRC}/PlacesTile.h
                ${UNITY_SRC}/PlacesSimpleTile.cpp
                ${UNITY_SRC}/PlacesSimpleTile.h
                ${UNITY_SRC}/PlacesVScrollBar.cpp
                ${UNITY_SRC}/PlacesVScrollBar.h
                ${UNITY_SRC}/DashView.cpp
                ${UNITY_SRC}/DashView.h
                ${UNITY_SRC}/HomeView.cpp
                ${UNITY_SRC}/HomeView.h
                ${UNITY_SRC}/DashStyle.cpp
                ${UNITY_SRC}/IconLoader.cpp
                ${UNITY_SRC}/IconLoader.h
                ${UNITY_SRC}/IconTexture.cpp
                ${UNITY_SRC}/IconTexture.h
                ${UNITY_SRC}/Introspectable.cpp
                ${UNITY_SRC}/Introspectable.h
                ${UNITY_SRC}/JSONParser.cpp
                ${UNITY_SRC}/LensBar.cpp
                ${UNITY_SRC}/LensBar.h
                ${UNITY_SRC}/LensBarIcon.cpp
                ${UNITY_SRC}/LensBarIcon.h
                ${UNITY_SRC}/LensView.cpp
                ${UNITY_SRC}/LensView.h
                ${UNITY_SRC}/PreviewApplications.cpp
                ${UNITY_SRC}/PreviewBase.cpp
                ${UNITY_SRC}/PreviewBasicButton.cpp
                ${UNITY_SRC}/ResultView.cpp
                ${UNITY_SRC}/ResultViewGrid.cpp
                ${UNITY_SRC}/ResultRenderer.cpp
                ${UNITY_SRC}/ResultRendererTile.cpp
                ${UNITY_SRC}/ResultRendererHorizontalTile.cpp
                ${UNITY_SRC}/TextureCache.h
                ${UNITY_SRC}/TextureCache.cpp
                ${UNITY_SRC}/Timer.cpp
                ${UNITY_SRC}/Timer.h
                ${UNITY_SRC}/StaticCairoText.cpp
                ${UNITY_SRC}/StaticCairoText.h
                ${UNITY_SRC}/UBusMessages.h
                ${UNITY_SRC}/UBusWrapper.cpp
                ${UNITY_SRC}/UBusWrapper.h
                ${UNITY_SRC}/ubus-server.cpp
                ${UNITY_SRC}/ubus-server.h
                ${UNITY_SRC}/UScreen.cpp
                ${UNITY_SRC}/UScreen.h
                )
add_dependencies (standalone-dash unity-core-${UNITY_API_VERSION})


#
# Please use "standalone-$foo" naming convention for standalone tests
#
add_executable (test-panel
                TestPanel.cpp
                ${UNITY_SRC}/Animator.cpp
                ${UNITY_SRC}/Animator.h
                ${UNITY_SRC}/BackgroundEffectHelper.cpp
                ${UNITY_SRC}/BackgroundEffectHelper.h
                ${UNITY_SRC}/DashSettings.cpp
                ${UNITY_SRC}/DashSettings.h
                ${UNITY_SRC}/PanelStyle.cpp
                ${UNITY_SRC}/PanelStyle.h
                ${UNITY_SRC}/PanelView.cpp
                ${UNITY_SRC}/PanelView.h
                ${UNITY_SRC}/PanelIndicatorsView.cpp
                ${UNITY_SRC}/PanelIndicatorsView.h
                ${UNITY_SRC}/PanelIndicatorEntryView.cpp
                ${UNITY_SRC}/PanelIndicatorEntryView.h
                ${UNITY_SRC}/PanelTitlebarGrabAreaView.h
                ${UNITY_SRC}/PanelTitlebarGrabAreaView.cpp
                ${UNITY_SRC}/PanelTray.cpp
                ${UNITY_SRC}/PanelTray.h
                ${UNITY_SRC}/Introspectable.cpp
                ${UNITY_SRC}/Introspectable.h
                ${UNITY_SRC}/PanelMenuView.cpp
                ${UNITY_SRC}/PanelMenuView.h
                ${UNITY_SRC}/Timer.cpp
                ${UNITY_SRC}/Timer.h
                ${UNITY_SRC}/StaticCairoText.cpp
                ${UNITY_SRC}/StaticCairoText.h
                ${UNITY_SRC}/WindowButtons.cpp
                ${UNITY_SRC}/WindowButtons.h
                ${UNITY_SRC}/WindowManager.cpp
                ${UNITY_SRC}/WindowManager.h
                ${UNITY_SRC}/UScreen.cpp
                ${UNITY_SRC}/UScreen.h
                ${UNITY_SRC}/ubus-server.cpp
                ${UNITY_SRC}/ubus-server.h
                )
add_dependencies (test-panel unity-core-${UNITY_API_VERSION})

add_executable (test-switcher
                TestSwitcher.cpp
                ${UNITY_SRC}/AbstractLauncherIcon.h
                ${UNITY_SRC}/AbstractIconRenderer.h
                ${UNITY_SRC}/SwitcherController.cpp
                ${UNITY_SRC}/SwitcherController.h
                ${UNITY_SRC}/SwitcherModel.cpp
                ${UNITY_SRC}/SwitcherModel.h
                ${UNITY_SRC}/SwitcherView.cpp
                ${UNITY_SRC}/SwitcherView.h
                ${UNITY_SRC}/LayoutSystem.h
                ${UNITY_SRC}/LayoutSystem.cpp
                ${UNITY_SRC}/WindowManager.h
                ${UNITY_SRC}/WindowManager.cpp
                ${UNITY_SRC}/IconRenderer.cpp
                ${UNITY_SRC}/IconRenderer.h
                ${UNITY_SRC}/MockLauncherIcon.h
                ${UNITY_SRC}/BackgroundEffectHelper.h
                ${UNITY_SRC}/BackgroundEffectHelper.cpp
                ${UNITY_SRC}/StaticCairoText.cpp
                ${UNITY_SRC}/StaticCairoText.h
                ${UNITY_SRC}/UBusMessages.h
                ${UNITY_SRC}/ubus-server.cpp
                ${UNITY_SRC}/ubus-server.h
                )
add_dependencies (test-switcher unity-core-${UNITY_API_VERSION})

add_executable (test-launcher
                TestLauncher.cpp
                ${UNITY_SRC}/AbstractLauncherIcon.h
                ${UNITY_SRC}/AbstractIconRenderer.h
                ${UNITY_SRC}/LauncherIcon.cpp
                ${UNITY_SRC}/LauncherIcon.h
                ${UNITY_SRC}/SimpleLauncherIcon.cpp
                ${UNITY_SRC}/SimpleLauncherIcon.h
                ${UNITY_SRC}/BamfLauncherIcon.cpp
                ${UNITY_SRC}/BamfLauncherIcon.h
                ${UNITY_SRC}/BFBLauncherIcon.cpp
                ${UNITY_SRC}/BFBLauncherIcon.h
                ${UNITY_SRC}/SpacerLauncherIcon.cpp
                ${UNITY_SRC}/SpacerLauncherIcon.h
                ${UNITY_SRC}/DndData.cpp
                ${UNITY_SRC}/DndData.h
                ${UNITY_SRC}/TrashLauncherIcon.cpp
                ${UNITY_SRC}/TrashLauncherIcon.h
                ${UNITY_SRC}/DNDCollectionWindow.cpp
                ${UNITY_SRC}/DNDCollectionWindow.h
                ${UNITY_SRC}/DeviceLauncherIcon.cpp
                ${UNITY_SRC}/DeviceLauncherIcon.h
                ${UNITY_SRC}/DeviceLauncherSection.cpp
                ${UNITY_SRC}/DeviceLauncherSection.h
                ${UNITY_SRC}/DevicesSettings.cpp
                ${UNITY_SRC}/DevicesSettings.h
                ${UNITY_SRC}/FavoriteStore.cpp
                ${UNITY_SRC}/FavoriteStore.h
                ${UNITY_SRC}/FavoriteStoreGSettings.cpp
                ${UNITY_SRC}/FavoriteStoreGSettings.h
                ${UNITY_SRC}/LauncherEntryRemoteModel.cpp
                ${UNITY_SRC}/LauncherEntryRemoteModel.h
                ${UNITY_SRC}/LauncherEntryRemote.cpp
                ${UNITY_SRC}/LauncherEntryRemote.h
                ${UNITY_SRC}/LauncherController.cpp
                ${UNITY_SRC}/LauncherController.h
                ${UNITY_SRC}/LauncherModel.cpp
                ${UNITY_SRC}/LauncherModel.h
                ${UNITY_SRC}/Launcher.cpp
                ${UNITY_SRC}/Launcher.h
                ${UNITY_SRC}/LauncherHideMachine.cpp
                ${UNITY_SRC}/LauncherHideMachine.h
                ${UNITY_SRC}/LauncherHoverMachine.cpp
                ${UNITY_SRC}/LauncherHoverMachine.h
                ${UNITY_SRC}/LauncherDragWindow.cpp
                ${UNITY_SRC}/LauncherDragWindow.h
                ${UNITY_SRC}/GeisAdapter.cpp
                ${UNITY_SRC}/GeisAdapter.h
                ${UNITY_SRC}/WindowManager.h
                ${UNITY_SRC}/WindowManager.cpp
                ${UNITY_SRC}/IconRenderer.cpp
                ${UNITY_SRC}/IconRenderer.h
                ${UNITY_SRC}/Tooltip.cpp
                ${UNITY_SRC}/Tooltip.h
                ${UNITY_SRC}/BackgroundEffectHelper.h
                ${UNITY_SRC}/BackgroundEffectHelper.cpp
                ${UNITY_SRC}/StaticCairoText.cpp
                ${UNITY_SRC}/StaticCairoText.h
                ${UNITY_SRC}/Introspectable.cpp
                ${UNITY_SRC}/Introspectable.h
                ${UNITY_SRC}/QuicklistMenuItem.cpp
                ${UNITY_SRC}/QuicklistMenuItem.h
                ${UNITY_SRC}/QuicklistMenuItemCheckmark.cpp

=== plugins/unity-mt-grab-handles/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

compiz_plugin (unitymtgrabhandles PLUGINDEPS composite opengl)

=== tests/test-get-transients/CMakeLists.txt ===
project (test-input-remover)

include (FindPkgConfig)

pkg_check_modules (COMPIZ_TEST_GET_TRANSIENTS REQUIRED x11 xext)

if (COMPIZ_TEST_GET_TRANSIENTS_FOUND)
	include_directories (${COMPIZ_TEST_GET_TRANSIENTS_INCLUDE_DIRS}
			     ..
			     ../../plugins/unityshell/src)

	link_directories (${COMPIZ_TEST_GET_TRANSIENTS_LINK_DIRS})

	add_executable (test-get-transients
			test-get-transients.cpp
			../../plugins/unityshell/src/transientfor.cpp
			../../plugins/unityshell/src/inputremover.cpp
			../x11-window.cpp
			../x11-window-read-transients.cpp)

	target_link_libraries (test-get-transients
			       ${COMPIZ_TEST_GET_TRANSIENTS_LIBRARIES})
	add_dependencies (test-get-transients unity-core-${UNITY_API_VERSION})

endif (COMPIZ_TEST_GET_TRANSIENTS_FOUND)

=== tests/test-input-remover/CMakeLists.txt ===
project (test-input-remover)

include (FindPkgConfig)

pkg_check_modules (COMPIZ_TEST_INPUT_REMOVER REQUIRED x11 xext)

if (COMPIZ_TEST_INPUT_REMOVER_FOUND)
	include_directories (${COMPIZ_TEST_INPUT_REMOVER_INCLUDE_DIRS}
			     ../../plugins/unityshell/src)

	link_directories (${COMPIZ_TEST_INPUT_REMOVER_LINK_DIRS})

	add_executable (test-input-remover
			test-input-remover.cpp
			../../plugins/unityshell/src/inputremover.cpp)

	target_link_libraries (test-input-remover
			       ${COMPIZ_TEST_INPUT_REMOVER_LIBRARIES})
	add_dependencies (test-input-remover unity-core-${UNITY_API_VERSION})

endif (COMPIZ_TEST_INPUT_REMOVER_FOUND)

=== tests/test-minimize-window-handler/CMakeLists.txt ===
project (test-input-remover)

include (FindPkgConfig)

pkg_check_modules (COMPIZ_TEST_MINIMIZED_HANDER REQUIRED x11 xext)

if (COMPIZ_TEST_MINIMIZED_HANDER_FOUND)
	include_directories (${COMPIZ_TEST_MINIMIZED_HANDER_INCLUDE_DIRS}
			     ..
			     ../../plugins/unityshell/src)

	link_directories (${COMPIZ_TEST_MINIMIZED_HANDER_LINK_DIRS})

	add_executable (test-minimize-handler
			test-minimize-handler.cpp
			../../plugins/unityshell/src/minimizedwindowhandler.cpp
			../x11-window.cpp
			../x11-window-read-transients.cpp
			../../plugins/unityshell/src/transientfor.cpp
			../../plugins/unityshell/src/inputremover.cpp)

	target_link_libraries (test-minimize-handler
			       ${COMPIZ_TEST_MINIMIZED_HANDER_LIBRARIES})
	add_dependencies (test-minimize-handler unity-core-${UNITY_API_VERSION})

endif (COMPIZ_TEST_MINIMIZED_HANDER_FOUND)

=== debian/changelog ===
unity (4.30.0-0ubuntu1) oneiric-proposed; urgency=low

  [ Francis Ginther ]
  * Updated build dependencies on the renamed libgrail and libgeis
    (LP: #1047385)

  [ Łukasz 'sil2100' Zemczak ]
  * New upstream release.
    - Update dependency on renamed geis (LP: #1047385)
  * Removed debian/patches/add_postrelease_buildfix.patch

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Wed, 12 Sep 2012 15:34:05 +0200

unity (4.28.0-0ubuntu2) oneiric-proposed; urgency=low

  * Cherry-pick some additional fixes:
    - fix a regression where transparency is setup on the panel (LP: #830949)
    - the wrong commit causing a crash was revert. Revert the revert and
      revert the right guilty commit.

 -- Didier Roche <didrocks@ubuntu.com>  Thu, 19 Jan 2012 09:54:44 +0100

unity (4.28.0-0ubuntu1) oneiric-proposed; urgency=low

  * New upstream release.
    - don't segfault in geis_configuration_get_value() (lp: #850623)
    - get focus on dash by pressing the super key first time after login 
      (lp: #860805)
    - clicking on panel when dash is open no longer causes maximized window 
      to raise (lp: #873100)
    - window management, alt-tab - After using 'show desktop' to minimise all 
      windows, opening any new window also incorrectly restores all 
      the minimised windows (lp: #871801)
    - compiz crashed with SIGSEGV in 
      unity::switcher::SwitcherModel::DetailSelectionWindow() (lp: #834630)
    - compiz crashed with SIGSEGV in g_strcmp0() (lp: #832151)
    - compiz crashed with SIGSEGV in nux::BaseWindow::GetInputWindowId() 
      (when onboard is used) (lp: #865890)
    - fix multi-monitor crashers (lp: #838128, #864037, #864784, #868120)
    - Fix SIGSEGV after SwitcherController desctruction (lp: #887465)
    - Fix for "right-clicking launcher when choosing a workspace causes
      quicklists to freeze" (lp: #791810)
  * debian/patches/add_postrelease_buildfix.patch:
    - add post-release fix to build in a clean env
  * backport some additional reverts or regression fixes

 -- Didier Roche <didrocks@ubuntu.com>  Fri, 06 Jan 2012 09:42:04 +0100

unity (4.24.0-0ubuntu2.1) oneiric-proposed; urgency=low

  * Backported fix for lp: #856205
    "run the wrong command if enter is hit before the view is refreshed"

 -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 12 Dec 2011 18:48:44 +0100

unity (4.24.0-0ubuntu2b1) oneiric-proposed; urgency=low

  * No-change reupload because of broken powerpc build.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 25 Oct 2011 07:01:51 +0200

unity (4.24.0-0ubuntu2) oneiric-proposed; urgency=low

  * Cherry-pick upstream:
    - SRU0-Regression: scrollbar displacement caused dash rows to show less
      icons (LP: #875023)
    - Really reverts the UI change that was still uploaded even if we had
      reverted it…

 -- Didier Roche <didrocks@ubuntu.com>  Tue, 18 Oct 2011 12:47:54 +0200

unity (4.24.0-0ubuntu1) oneiric-proposed; urgency=low

  * New upstream release and some cherry-pick:
    - compiz crashed with SIGSEGV in PluginClassHandler<UnityWindow,
      CompWindow, 0>::get() (LP: #864758)
    - unity panel menus don't stay open when clicked on second monitor
      (LP: #869196)
    - (oneiric) menu bar in wrong place and invisible (LP: #845856)
    - Lens range widgets do not function correctly (LP: #862996)
    - Cannot raise window from panel after minimize (LP: #863114)
    - unity-panel-service crashed with SIGSEGV in g_closure_invoke()
      (LP: #843280)
    - Windows get corrupted sometimes when semi-maximizing them. (LP: #865177)
    - Automaximization happens on unminimize (LP: #868930)
    - compiz crashed with SIGSEGV in nux::ROProperty<std::string>::operator
      std::string() (LP: #869109)
    - Dash - horizental divider line in between categories incorrectly drawn
      (LP: #841750)
    - F10 opens a random menu item when it should open the first one
      [regression] (LP: #862849)
    - Switching desktops after using showdesktop can cause hidden windows to
      become "active" (LP: #864503)
    - Clicking blank space on top panel doesn't raise maximized window to
      front (LP: #864708)
    - unity launcher loses track of deja-dup windows (LP: #865051)
    - Dash - App Lens 'Rating' filter behaves incorrectly (LP: #865482)
    - Launcher does not show on "Show desktop" (LP: #867959)
    - ibus character selection window not drawn (LP: #867885)
    - the dash's entry get wrongly colored on left or right key use
      (LP: #868434)
    - [ibus] Pressing down when ibus is active moves focus (LP: #872730)
    - Double-click on the dash top panel is taken effect on the window
      underneith (LP: #870844)

 -- Didier Roche <didrocks@ubuntu.com>  Mon, 17 Oct 2011 09:20:09 +0200

=== debian/control ===
Source: unity
Section: gnome
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: cmake,
               debhelper (>= 7.0.50~),
               dh-translations (>= 94),
               pkg-config,
               intltool (>= 0.35.0),
               libsigc++-2.0-dev,
               libgee-dev (>= 0.5.0),
               libunique-dev,
               libbamf3-dev (>= 0.2.92),
               gsettings-desktop-schemas-dev,
               libgconf2-dev,
               libglib2.0-dev (>= 2.22.2-0ubuntu1wncksync3),
               libdbusmenu-glib-dev (>= 0.3.91),
               libgnome-desktop-dev,
               libgtk2.0-dev (>= 2.18.0),
               libgtk-3-dev (>= 3.1),
               libcairo2-dev,
               libpango1.0-dev,
               libdee-dev (>= 0.5.4),
               libindicator-dev (>= 0.3.90),
               libindicator3-dev (>= 0.3.90),
               libunity-misc-dev (>= 4.0.4),
               libgrail-dev (>= 1.0.20),
               libxcb-icccm4-dev,
               libnux-1.0-dev (>= 1.12.0),
               compiz-dev (>= 1:0.9.5.94+bzr2803-0ubuntu1~),
               libcompizconfig0-dev (>= 0.9.2.1git101125),
               xsltproc,
               libboost1.46-dev,
               libboost-serialization1.46-dev,
               libnotify-dev,
               libstartup-notification0-dev,
               libatk1.0-dev,
               libjson-glib-dev,
               libgeis-dev (>= 2.0.10),
               libgnome-desktop-3-dev,
               libunity-dev (>= 4.0.2~),
Standards-Version: 3.9.2
Homepage: https://launchpad.net/unity
Vcs-Bzr: https://code.launchpad.net/~ubuntu-desktop/unity/oneiric

Package: unity
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         unity-common (= ${source:Version}),
         compiz,
         compiz-core, compiz-core-abiversion-${coreabiversion},
         compiz-plugins-main-default,
         libglib2.0-bin,
         python,
         nux-tools,
         unity-asset-pool (>= 0.8.18)
Provides: indicator-renderer,
          netbook-launcher
Conflicts: netbook-launcher (<< 1:2.1.18-0ubuntu2)
Replaces: netbook-launcher (<< 1:2.1.18-0ubuntu2),
          unity-common (<< 4.0.1-0ubuntu2~)
Recommends: unity-lens-applications,
            unity-lens-files,
            unity-lens-music,
            indicator-appmenu,
            indicator-application,
            indicator-sound,
            indicator-datetime,
            indicator-messages,
            indicator-power,
            indicator-session,
Breaks: compiz-core (<< 1:0.9.4+bzr20110606-0ubuntu5),
        bamf (<< 0.2.76),
Description: Interface designed for efficiency of space and interaction.
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.

Package: unity-services
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
Replaces: unity (<< 4.0.1-0ubuntu1~),
          unity-common (<< 4.0.1-0ubuntu2~),
Description: Services for the Unity interface
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.
 .
 This package contains the dbus service used for unity and unity-2d.

Package: unity-common
Architecture: all
Depends: ${misc:Depends},
         python,
Replaces: unity (<< 4.0.1-0ubuntu1~)
Conflicts: unity (<< 3.2.2-0ubuntu3)
Description: Common files for the Unity interface.
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.
 .
 This package contains commons file that are architecture independent.

Package: libunity-core-4.0-4
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         unity-services (= ${binary:Version}),
Description: Core library for the Unity interface.
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.
 .
 This package contains shared libraries to be used by unity-3d and unity-2d.

Package: libunity-core-4.0-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libunity-core-4.0-4 (= ${binary:Version}),
         libglib2.0-dev,
         libsigc++-2.0-dev,
         libnux-1.0-dev (>= 1.0.2),
         libunity-dev (>= 4.0.0~),
         libdee-dev,
Description: Core library for the Unity interface - development files
 Unity is a desktop experience that sings. Designed by Canonical and the Ayatana
 community, Unity is all about the combination of familiarity and the future. We
 bring together visual design, analysis of user experience testing, modern
 graphics technologies and a deep understanding of the free software landscape
 to produce what we hope will be the lightest, most elegant and most delightful
 way to use your PC.
 .
 This package contains development files for libraries to be used by unity-3d
 and unity-2d.

Package: netbook-launcher
Section: oldlibs
Architecture: all
Depends: unity, ${misc:Depends}
Description: transitional package
 unity supersedes netbook-launcher. This package ensures a clean upgrade path,
 and can be safely removed after the upgrade.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')

CFLAGS=$(shell echo $$CFLAGS | sed -e 's/\-Wall//')

CORE_ABIVERSION := $(shell sed -rn 's/^\#define[[:space:]]+CORE_ABIVERSION[[:space:]]+//p' /usr/include/compiz/core/core.h )

override_dh_auto_configure:
	dh_auto_configure -- -DCOMPIZ_BUILD_WITH_RPATH=FALSE -DCOMPIZ_PACKAGING_ENABLED=TRUE -DCOMPIZ_PLUGIN_INSTALL_TYPE=package

override_dh_install:
	find debian/tmp/usr/lib -name \*.*a -exec rm {} \;
	rm -f debian/tmp/usr/share/compiz/networkarearegion.xml
	rm -f debian/tmp//usr/lib/compiz/libnetworkarearegion.so
	rm -f debian/tmp/usr/share/compiz/unitydialog.xml
	rm -f debian/tmp/usr/lib/compiz/libunitydialog.so
	dh_install --fail-missing

override_dh_gencontrol:
	dh_gencontrol -- -Vcoreabiversion=$(CORE_ABIVERSION)
	# override netbook-launcher on i386 to get an epoch
	rm -f debian/netbook-launcher/DEBIAN/control
	dh_gencontrol -pnetbook-launcher -- -Vcoreabiversion=$(CORE_ABIVERSION) -v2:$(DEB_VERSION)

override_dh_makeshlibs:
	dh_makeshlibs -plibunity-core-4.0-4 -V 'libunity-core-4.0-4 (>= 4.14.2)'

override_dh_auto_test:
	echo "not working right now"

%:
	dh $@ --with translations

=== debian/watch ===
version=3
https://launchpad.net/unity/+download .*/unity-([0-9.]+)\.tar\.bz2
